import AlteryxPythonSDK as Sdk
import engine.sf_metadata as sf_metadata
import engine.sf_utils as sf_utils
import engine.sf_queries as sf_queries
from moz_sql_parser import parse

def pass_metadata(self):
    if self.query_type == 'queryBuilder':
        self.header_list = sf_metadata.map_field_types(metadata_list=self.metadata_list)
    elif self.query_type == 'customQuery':
        if self.json_parse == 'False':
            self.header_list = [{'name': 'JSON', 'type': Sdk.FieldType.v_wstring, 'length': 1073741823, 'scale': 0, 'label': 'JSON'}]
        else:
            try:
                self.field_names, self.table = parse_custom_query(self=self, query=self.query)
                self.parse_query_flag = parsable_flag(self=self, field_list=self.field_names)
                if self.parse_query_flag == 'output_json':
                    self.header_list = [{'name': 'JSON', 'type': Sdk.FieldType.v_wstring, 'length': 1073741823, 'scale': 0, 'label': 'JSON'}]
                else:
                    metadata = sf_metadata.retrieve_metadata(self=self, table_name=self.table, field_names=self.field_names)
                    self.header_list = sf_metadata.map_field_types(metadata_list=metadata)
            
                return self.header_list, self.parse_query_flag

            except:
                pass
            
def parse_custom_query(self, query):
        parsed_query = parse(query)
        select_list = parsed_query['select']
        self.field_names = [field_name['value'] if type(select_list) == list else select_list['value'] for field_name in select_list]
        self.table_name = parsed_query['from']

        return self.field_names, self.table_name


def parsable_flag(self, field_list):
    if [element for element in field_list if type(element) == dict] or [element for element in field_list if element.count('.') > 1]:
        return 'output_json'
    elif [element for element in field_list if element.count('.') == 1]:
        return 'dot_query'
    else:
        return 'simple_query'