import AlteryxPythonSDK as Sdk
import xml.etree.ElementTree as Et

def display_msg(self, type: str, msg_string: str):
    """
    A non-interface method, that is responsible for displaying the relevant error message in Designer.
    :param msg_string: The custom error message.
    """

    self.is_initialized = False
    if type == 'info':
      self.alteryx_engine.output_message(self.n_tool_id, Sdk.EngineMessageType.info, str(msg_string))
    elif type == 'warning':
      self.alteryx_engine.output_message(self.n_tool_id, Sdk.EngineMessageType.warning, str(msg_string))
    elif type == 'error':
      self.alteryx_engine.output_message(self.n_tool_id, Sdk.EngineMessageType.error,str(msg_string))
    else:
      return print('Type not info, warning, or error')

def get_xml_config_value(str_xml: str, config_key: str) -> str:
  return Et.fromstring(str_xml).find(config_key).text if config_key in str_xml else None